import React, { Component } from "react";

export default WrapperComponent =>
	class extends Component {
		state = {
			width: window.innerWidth
		};

		componentDidMount() {
			window.addEventListener("resize", this.resize);
		}

		componentWillUnmount() {
			window.removeEventListener("resize", this.resize);
		}

		resize = () => this.setState({ width: window.innerWidth });

		render() {
			const { width } = this.state;
			return <WrapperComponent width={width} {...this.props} />;
		}
	};
