import React, { Component } from "react";
import "./App.css";

import axios from "axios";
import { Consumer } from "../index";

import Loader from "../components/HOC/loader";
import WrapperComponent from "../components/HOC/resize";

class App extends Component {
	state = { category: [], isFetching: false };

	async componentDidMount() {
		this.setState({ isFetching: true }); // 1
		try {
			const token = localStorage.getItem("token");
			const response = await axios({
				url: "https://test-app-a-level.herokuapp.com/category",
				method: "GET",
				headers: {
					"Content-Type": "application/json",
					Authorization: `Bearer ${token}`
				},
				params: {
					page: 1,
					size: 50
				}
			});
			this.setState({ category: response.data.category, isFetching: false }); // 2

			console.log("response", response);
		} catch (e) {
			console.log("e", e.response);
			this.setState({ isFetching: false });
		}
		// console.log("this.", this.props);
	}

	render() {
		const { category, isFetching } = this.state;

		console.log("w", this.props);

		return (
			<div className="App">
				<header className="App-header">
					<Consumer>
						{({ count, changeCount }) => (
							<div>
								{count}
								<span onClick={changeCount}>Inc</span>
							</div>
						)}
					</Consumer>
					<p className="foo">
						Edit <code>src/App.js</code> and save to reload.
					</p>
					<a className="App-link" href="https://reactjs.org" target="_blank" rel="noopener noreferrer">
						Learn React
					</a>
				</header>
				<Loader flag={isFetching}>
					{category.map(el => (
						<div key={el._id}>
							<p>{el.name}</p>
						</div>
					))}
				</Loader>
			</div>
		);
	}
}

export default WrapperComponent(App);
